package io.dekorate.kubernetes.config;

import java.lang.String;
import io.dekorate.kubernetes.annotation.ServiceType;
import java.lang.Boolean;
import io.sundr.builder.annotations.Buildable;
import java.lang.Integer;
import io.dekorate.project.Project;
import io.dekorate.kubernetes.annotation.ImagePullPolicy;
import java.lang.Object;
import java.util.Map;

@Buildable(builderPackage = "io.fabric8.kubernetes.api.builder") public class KubernetesConfig extends BaseConfig {

    private io.dekorate.kubernetes.config.Container[] initContainers = new io.dekorate.kubernetes.config.Container[0];
    private Integer replicas;
    private DeploymentStrategy deploymentStrategy;
    private io.dekorate.kubernetes.config.RollingUpdate rollingUpdate;
    private Boolean headless;

    public KubernetesConfig() {
    }

    public KubernetesConfig(Project project,Map<ConfigKey,Object> attributes,String partOf,String name,String version,io.dekorate.kubernetes.config.Label[] labels,io.dekorate.kubernetes.config.Annotation[] annotations,io.dekorate.kubernetes.config.Env[] envVars,String workingDir,String[] command,String[] arguments,String serviceAccount,String host,io.dekorate.kubernetes.config.Port[] ports,ServiceType serviceType,io.dekorate.kubernetes.config.PersistentVolumeClaimVolume[] pvcVolumes,io.dekorate.kubernetes.config.SecretVolume[] secretVolumes,io.dekorate.kubernetes.config.ConfigMapVolume[] configMapVolumes,io.dekorate.kubernetes.config.GitRepoVolume[] gitRepoVolumes,io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume[] awsElasticBlockStoreVolumes,io.dekorate.kubernetes.config.AzureDiskVolume[] azureDiskVolumes,io.dekorate.kubernetes.config.AzureFileVolume[] azureFileVolumes,io.dekorate.kubernetes.config.Mount[] mounts,ImagePullPolicy imagePullPolicy,String[] imagePullSecrets,io.dekorate.kubernetes.config.HostAlias[] hostAliases,io.dekorate.kubernetes.config.Probe livenessProbe,io.dekorate.kubernetes.config.Probe readinessProbe,io.dekorate.kubernetes.config.ResourceRequirements requestResources,io.dekorate.kubernetes.config.ResourceRequirements limitResources,io.dekorate.kubernetes.config.Container[] sidecars,Boolean expose,Boolean autoDeployEnabled,io.dekorate.kubernetes.config.Container[] initContainers,Integer replicas,DeploymentStrategy deploymentStrategy,io.dekorate.kubernetes.config.RollingUpdate rollingUpdate,Boolean headless) {
        super(project, attributes, partOf, name, version, labels, annotations, envVars, workingDir, command, arguments, serviceAccount, host, ports, serviceType, pvcVolumes, secretVolumes, configMapVolumes, gitRepoVolumes, awsElasticBlockStoreVolumes, azureDiskVolumes, azureFileVolumes, mounts, imagePullPolicy, imagePullSecrets, hostAliases, livenessProbe, readinessProbe, requestResources, limitResources, sidecars, expose, autoDeployEnabled);
        this.initContainers = initContainers != null ? initContainers : new io.dekorate.kubernetes.config.Container[0];
        this.replicas = replicas;
        this.deploymentStrategy = deploymentStrategy;
        this.rollingUpdate = rollingUpdate;
        this.headless = headless;
    }

    public io.dekorate.kubernetes.config.Container[] getInitContainers() {
        return this.initContainers;
    }

    public Integer getReplicas() {
        return this.replicas;
    }

    public DeploymentStrategy getDeploymentStrategy() {
        return this.deploymentStrategy;
    }

    public io.dekorate.kubernetes.config.RollingUpdate getRollingUpdate() {
        return this.rollingUpdate;
    }

    public Boolean getHeadless() {
        return this.headless;
    }

    public boolean isHeadless() {
        return this.headless != null &&  this.headless;
    }

    public static KubernetesConfigBuilder newKubernetesConfigBuilder() {
        return new io.dekorate.kubernetes.config.KubernetesConfigBuilder();
    }

    public static KubernetesConfigBuilder newKubernetesConfigBuilderFromDefaults() {
        return new io.dekorate.kubernetes.config.KubernetesConfigBuilder().withReplicas(1).withDeploymentStrategy(io.dekorate.kubernetes.config.DeploymentStrategy.None).withServiceType(io.dekorate.kubernetes.annotation.ServiceType.ClusterIP).withImagePullPolicy(io.dekorate.kubernetes.annotation.ImagePullPolicy.IfNotPresent).withExpose(false).withHeadless(false).withAutoDeployEnabled(false);
    }

    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        if (!super.equals(o)) return false;
        KubernetesConfig that = (KubernetesConfig) o;
        if (initContainers != null ? !initContainers.equals(that.initContainers) :that.initContainers != null) return false;
        if (replicas != null ? !replicas.equals(that.replicas) :that.replicas != null) return false;
        if (deploymentStrategy != null ? !deploymentStrategy.equals(that.deploymentStrategy) :that.deploymentStrategy != null) return false;
        if (rollingUpdate != null ? !rollingUpdate.equals(that.rollingUpdate) :that.rollingUpdate != null) return false;
        if (headless != null ? !headless.equals(that.headless) :that.headless != null) return false;
        return true;
    }

    public int hashCode() {
        return java.util.Objects.hash(initContainers,  replicas,  deploymentStrategy,  rollingUpdate,  headless,  super.hashCode());
    }

}
