package io.dekorate.kubernetes.config;

import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import io.fabric8.kubernetes.api.builder.Nested;
import java.util.ArrayList;
import java.lang.String;
import java.util.function.Predicate;
import java.lang.Deprecated;
import io.dekorate.kubernetes.annotation.ServiceType;
import java.util.Iterator;
import java.lang.Boolean;
import java.lang.Integer;
import io.dekorate.project.Project;
import io.dekorate.kubernetes.annotation.ImagePullPolicy;
import java.util.Collection;
import java.lang.Object;
import java.util.Map;

public interface KubernetesConfigFluent<A extends KubernetesConfigFluent<A>> extends BaseConfigFluent<A> {


    public A withInitContainers(io.dekorate.kubernetes.config.Container... initContainers);
    
/**
 * This method has been deprecated, please use method buildInitContainers instead.
 */
@Deprecated public io.dekorate.kubernetes.config.Container[] getInitContainers();
    public io.dekorate.kubernetes.config.Container[] buildInitContainers();
    public io.dekorate.kubernetes.config.Container buildInitContainer(int index);
    public io.dekorate.kubernetes.config.Container buildFirstInitContainer();
    public io.dekorate.kubernetes.config.Container buildLastInitContainer();
    public io.dekorate.kubernetes.config.Container buildMatchingInitContainer(Predicate<ContainerBuilder> predicate);
    public Boolean hasMatchingInitContainer(Predicate<ContainerBuilder> predicate);
    public A addToInitContainers(int index,io.dekorate.kubernetes.config.Container item);
    public A setToInitContainers(int index,io.dekorate.kubernetes.config.Container item);
    public A addToInitContainers(io.dekorate.kubernetes.config.Container... items);
    public A addAllToInitContainers(Collection<io.dekorate.kubernetes.config.Container> items);
    public A removeFromInitContainers(io.dekorate.kubernetes.config.Container... items);
    public A removeAllFromInitContainers(Collection<io.dekorate.kubernetes.config.Container> items);
    public A removeMatchingFromInitContainers(Predicate<ContainerBuilder> predicate);
    public Boolean hasInitContainers();
    public KubernetesConfigFluent.InitContainersNested<A> addNewInitContainer();
    public KubernetesConfigFluent.InitContainersNested<A> addNewInitContainerLike(io.dekorate.kubernetes.config.Container item);
    public KubernetesConfigFluent.InitContainersNested<A> setNewInitContainerLike(int index,io.dekorate.kubernetes.config.Container item);
    public KubernetesConfigFluent.InitContainersNested<A> editInitContainer(int index);
    public KubernetesConfigFluent.InitContainersNested<A> editFirstInitContainer();
    public KubernetesConfigFluent.InitContainersNested<A> editLastInitContainer();
    public KubernetesConfigFluent.InitContainersNested<A> editMatchingInitContainer(Predicate<ContainerBuilder> predicate);
    public Integer getReplicas();
    public A withReplicas(Integer replicas);
    public Boolean hasReplicas();
    public DeploymentStrategy getDeploymentStrategy();
    public A withDeploymentStrategy(DeploymentStrategy deploymentStrategy);
    public Boolean hasDeploymentStrategy();
    
/**
 * This method has been deprecated, please use method buildRollingUpdate instead.
 * @return The buildable object.
 */
@Deprecated public io.dekorate.kubernetes.config.RollingUpdate getRollingUpdate();
    public io.dekorate.kubernetes.config.RollingUpdate buildRollingUpdate();
    public A withRollingUpdate(io.dekorate.kubernetes.config.RollingUpdate rollingUpdate);
    public Boolean hasRollingUpdate();
    public A withNewRollingUpdate(String maxUnavailable,String maxSurge);
    public KubernetesConfigFluent.RollingUpdateNested<A> withNewRollingUpdate();
    public KubernetesConfigFluent.RollingUpdateNested<A> withNewRollingUpdateLike(io.dekorate.kubernetes.config.RollingUpdate item);
    public KubernetesConfigFluent.RollingUpdateNested<A> editRollingUpdate();
    public KubernetesConfigFluent.RollingUpdateNested<A> editOrNewRollingUpdate();
    public KubernetesConfigFluent.RollingUpdateNested<A> editOrNewRollingUpdateLike(io.dekorate.kubernetes.config.RollingUpdate item);
    public Boolean getHeadless();
    public A withHeadless(Boolean headless);
    public Boolean hasHeadless();
    public A withNewHeadless(String arg1);
    public A withNewHeadless(boolean arg1);
    public interface InitContainersNested<N> extends Nested<N>,ContainerFluent<KubernetesConfigFluent.InitContainersNested<N>> {

            public N and();
            public N endInitContainer();    }


    public interface RollingUpdateNested<N> extends Nested<N>,RollingUpdateFluent<KubernetesConfigFluent.RollingUpdateNested<N>> {

            public N and();
            public N endRollingUpdate();    }


}
