package io.dekorate.kubernetes.config;

import java.lang.Object;
import java.lang.String;
import io.sundr.builder.annotations.Buildable;

@Buildable(builderPackage = "io.fabric8.kubernetes.api.builder") public class RollingUpdate {

    private String maxUnavailable;
    private String maxSurge;

    public RollingUpdate() {
    }

    public RollingUpdate(String maxUnavailable,String maxSurge) {
        this.maxUnavailable = maxUnavailable;
        this.maxSurge = maxSurge;
    }

    public String getMaxUnavailable() {
        return this.maxUnavailable;
    }

    public String getMaxSurge() {
        return this.maxSurge;
    }

    public static RollingUpdateBuilder newBuilder() {
        return new io.dekorate.kubernetes.config.RollingUpdateBuilder();
    }

    public static RollingUpdateBuilder newBuilderFromDefaults() {
        return new io.dekorate.kubernetes.config.RollingUpdateBuilder().withMaxUnavailable("25%").withMaxSurge("25%");
    }

    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        RollingUpdate that = (RollingUpdate) o;
        if (maxUnavailable != null ? !maxUnavailable.equals(that.maxUnavailable) :that.maxUnavailable != null) return false;
        if (maxSurge != null ? !maxSurge.equals(that.maxSurge) :that.maxSurge != null) return false;
        return true;
    }

    public int hashCode() {
        return java.util.Objects.hash(maxUnavailable,  maxSurge,  super.hashCode());
    }

}
