package io.dekorate.kubernetes.config;

import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;

public class RollingUpdateBuilder extends RollingUpdateFluentImpl<RollingUpdateBuilder> implements VisitableBuilder<io.dekorate.kubernetes.config.RollingUpdate,RollingUpdateBuilder> {

    RollingUpdateFluent<?> fluent;
    Boolean validationEnabled;

    public RollingUpdateBuilder() {
        this(true);
    }

    public RollingUpdateBuilder(Boolean validationEnabled) {
        this(new RollingUpdate(), validationEnabled);
    }

    public RollingUpdateBuilder(RollingUpdateFluent<?> fluent) {
        this(fluent, true);
    }

    public RollingUpdateBuilder(RollingUpdateFluent<?> fluent,Boolean validationEnabled) {
        this(fluent, new RollingUpdate(), validationEnabled);
    }

    public RollingUpdateBuilder(RollingUpdateFluent<?> fluent,io.dekorate.kubernetes.config.RollingUpdate instance) {
        this(fluent, instance, true);
    }

    public RollingUpdateBuilder(RollingUpdateFluent<?> fluent,io.dekorate.kubernetes.config.RollingUpdate instance,Boolean validationEnabled) {
        this.fluent = fluent; 
        fluent.withMaxUnavailable(instance.getMaxUnavailable()); 
        fluent.withMaxSurge(instance.getMaxSurge()); 
        this.validationEnabled = validationEnabled; 
    }

    public RollingUpdateBuilder(io.dekorate.kubernetes.config.RollingUpdate instance) {
        this(instance,true);
    }

    public RollingUpdateBuilder(io.dekorate.kubernetes.config.RollingUpdate instance,Boolean validationEnabled) {
        this.fluent = this; 
        this.withMaxUnavailable(instance.getMaxUnavailable()); 
        this.withMaxSurge(instance.getMaxSurge()); 
        this.validationEnabled = validationEnabled; 
    }

    public EditableRollingUpdate build() {
        EditableRollingUpdate buildable = new EditableRollingUpdate(fluent.getMaxUnavailable(),fluent.getMaxSurge());
        return buildable;
    }

    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        if (!super.equals(o)) return false;
        RollingUpdateBuilder that = (RollingUpdateBuilder) o;
        if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;
        
        if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
        return true;
    }

    public int hashCode() {
        return java.util.Objects.hash(fluent,  validationEnabled,  super.hashCode());
    }

}
