package io.dekorate.kubernetes.config;

import java.lang.StringBuffer;
import java.lang.StringBuilder;
import io.fabric8.kubernetes.api.builder.BaseFluent;
import java.lang.Object;
import java.lang.String;
import java.lang.Boolean;

public class RollingUpdateFluentImpl<A extends RollingUpdateFluent<A>> extends BaseFluent<A> implements RollingUpdateFluent<A> {

    private String maxUnavailable;
    private String maxSurge;

    public RollingUpdateFluentImpl() {
    }

    public RollingUpdateFluentImpl(io.dekorate.kubernetes.config.RollingUpdate instance) {
        this.withMaxUnavailable(instance.getMaxUnavailable()); 
        this.withMaxSurge(instance.getMaxSurge()); 
    }

    public String getMaxUnavailable() {
        return this.maxUnavailable;
    }

    public A withMaxUnavailable(String maxUnavailable) {
        this.maxUnavailable=maxUnavailable; return (A) this;
    }

    public Boolean hasMaxUnavailable() {
        return this.maxUnavailable != null;
    }

    public A withNewMaxUnavailable(String arg1) {
        return (A)withMaxUnavailable(new String(arg1));
    }

    public A withNewMaxUnavailable(StringBuilder arg1) {
        return (A)withMaxUnavailable(new String(arg1));
    }

    public A withNewMaxUnavailable(StringBuffer arg1) {
        return (A)withMaxUnavailable(new String(arg1));
    }

    public String getMaxSurge() {
        return this.maxSurge;
    }

    public A withMaxSurge(String maxSurge) {
        this.maxSurge=maxSurge; return (A) this;
    }

    public Boolean hasMaxSurge() {
        return this.maxSurge != null;
    }

    public A withNewMaxSurge(String arg1) {
        return (A)withMaxSurge(new String(arg1));
    }

    public A withNewMaxSurge(StringBuilder arg1) {
        return (A)withMaxSurge(new String(arg1));
    }

    public A withNewMaxSurge(StringBuffer arg1) {
        return (A)withMaxSurge(new String(arg1));
    }

    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        RollingUpdateFluentImpl that = (RollingUpdateFluentImpl) o;
        if (maxUnavailable != null ? !maxUnavailable.equals(that.maxUnavailable) :that.maxUnavailable != null) return false;
        if (maxSurge != null ? !maxSurge.equals(that.maxSurge) :that.maxSurge != null) return false;
        return true;
    }

    public int hashCode() {
        return java.util.Objects.hash(maxUnavailable,  maxSurge,  super.hashCode());
    }

}
